Lorene::ScalarBH Class Reference
Stationary compact objects (<em><strong>under development</strong></em>)

Black hole with scalar hair spacetime (under development). More...

`#include <compobj.h>`

Inheritance diagram for Lorene::ScalarBH:

## Public Member Functions

| ScalarBH (Map &mp_i, const char *file_name)
| Standard constructor.
| ScalarBH (const ScalarBH &)
| Copy constructor.
| ScalarBH (Map &mp_i, FILE *fich)
| Constructor from a file (see `sauve(FILE*)` ).
virtual | ~ScalarBH ()
| Destructor.
void | operator= (const ScalarBH &)
| Assignment to another `ScalarBH`.
const Scalar & | get_ff0 () const
| Returns f0.
const Scalar & | get_ff1 () const
const Scalar & | get_ff2 () const
const Scalar & | get_ww () const
const Scalar & | get_sfield () const
const double | get_rHor () const
virtual void | sauve (FILE *) const
| Save in a file.
virtual void | update_metric ()
Map & | set_mp ()
| Read/write of the mapping.
const Map & | get_mp () const
| Returns the mapping.
const Scalar & | get_nn () const
| Returns the lapse function N .
const Vector & | get_beta () const
| Returns the shift vector .
const Metric & | get_gamma () const
| Returns the 3-metric .
const Scalar & | get_ener_euler () const
| Returns the total energy density E in the Eulerian frame.
const Vector & | get_mom_euler () const
| Returns the total 3-momentum density in the Eulerian frame.
const Sym_tensor & | get_stress_euler () const
| Returns the stress tensor with respect to the Eulerian observer.
const Sym_tensor & | get_kk () const
| Returns the extrinsic curvature tensor .
void | gyoto_data (const char *file_name) const
| Save in a file for GYOTO.
virtual void | extrinsic_curvature ()
| Computation of the extrinsic curvature.
virtual double | adm_mass () const
| ADM mass (computed as a surface integral at spatial infinity).

## Protected Member Functions

virtual void | del_deriv () const
| Deletes all the derived quantities.
virtual void | set_der_0x0 () const
| Sets to `0x0` all the pointers on derived quantities.
virtual ostream & | operator>> (ostream &) const
| Operator >> (virtual function called by the operator <<).

## Protected Attributes

Scalar | ff0
| Metric field F_0 of Herdeiro & Radu (2015).
Scalar | ff1
| Metric field F_1 of Herdeiro & Radu (2015).
Scalar | ff2
| Metric field F_2 of Herdeiro & Radu (2015).
Scalar | ww
| Metric field W of Herdeiro & Radu (2015).
Scalar | sfield
| Scalar field (modulus of Phi).
double | rHor
| Event horizon coordinate radius.
Map & | mp
| Mapping describing the coordinate system (r,theta,phi).
Scalar | nn
| Lapse function N .
Vector | beta
| Shift vector .
Metric | gamma
| 3-metric
Scalar | ener_euler
| Total energy density E in the Eulerian frame.
Vector | mom_euler
| Total 3-momentum density in the Eulerian frame.
Sym_tensor | stress_euler
| Stress tensor with respect to the Eulerian observer.
Sym_tensor | kk
| Extrinsic curvature tensor .
double * | p_adm_mass
| ADM mass.

## Detailed Description

Black hole with scalar hair spacetime (under development).

()

The metric is expressed:

Definition at line 1020 of file compobj.h.

## Constructor & Destructor Documentation

## ScalarBH() [1/3]

Lorene::ScalarBH::ScalarBH | ( | Map & | mp_i,
|  | const char * | file_name )

Standard constructor.

Parameters

  mp_i | Mapping on which the star is contructed
  file_name | Name of the file containing the metric data
  a_spin_i | Spin parameter of the model

Definition at line 72 of file scalarBH.C.

References Lorene::Compobj::Compobj(), ff0, ff1, ff2, Lorene::Mg3d::get_np(), Lorene::Mg3d::get_nr(), Lorene::Mg3d::get_nt(), Lorene::Mg3d::get_nzone(), Lorene::Map(), Lorene::Compobj::mp, rHor, set_der_0x0(), sfield, Lorene::sqrt(), and ww.

## ScalarBH() [2/3]

Lorene::ScalarBH::ScalarBH | ( | const ScalarBH & | other | ) |

Copy constructor.

Definition at line 352 of file scalarBH.C.

References Lorene::Compobj::Compobj(), ff0, ff1, ff2, rHor, ScalarBH(), set_der_0x0(), sfield, and ww.

## ScalarBH() [3/3]

Lorene::ScalarBH::ScalarBH | ( | Map & | mp_i,
|  | FILE * | fich )

Constructor from a file (see `sauve(FILE*)` ).

Parameters

  mp_i | Mapping on which the star is constructed
  fich | input file (must have been created by the function `ScalarBH::sauve` )

Definition at line 368 of file scalarBH.C.

References Lorene::Compobj::Compobj(), ff0, ff1, ff2, Lorene::Map(), rHor, set_der_0x0(), sfield, and ww.

## ~ScalarBH()

Lorene::ScalarBH::~ScalarBH | ( |  | ) |

virtual

Destructor.

Definition at line 389 of file scalarBH.C.

References del_deriv().

## Member Function Documentation

## adm_mass()

double Lorene::Compobj::adm_mass | ( |  | ) | const

virtual inherited

ADM mass (computed as a surface integral at spatial infinity).

Definition at line 310 of file compobj.C.

References Lorene::Tensor::derive_con(), Lorene::Tensor_sym::derive_con(), Lorene::Vector::flux(), gamma, Lorene::Tensor::get_triad(), mp, p_adm_mass, Lorene::Tensor::trace(), and Lorene::Tensor::up().

## del_deriv()

void Lorene::ScalarBH::del_deriv | ( |  | ) | const

protected virtual

Deletes all the derived quantities.

Reimplemented from Lorene::Compobj.

Definition at line 400 of file scalarBH.C.

References Lorene::Compobj::del_deriv(), and set_der_0x0().

## extrinsic_curvature()

void Lorene::Compobj::extrinsic_curvature | ( |  | ) |

virtual inherited

Computation of the extrinsic curvature.

Reimplemented in Lorene::AltBH_QI, and Lorene::Compobj_QI.

Definition at line 290 of file compobj.C.

References beta, Lorene::Tensor::derive_cov(), gamma, kk, and nn.

## get_beta()

const Vector & Lorene::Compobj::get_beta | ( |  | ) | const

inline inherited

Returns the shift vector .

Definition at line 213 of file compobj.h.

References beta.

## get_ener_euler()

const Scalar & Lorene::Compobj::get_ener_euler | ( |  | ) | const

inline inherited

Returns the total energy density E in the Eulerian frame.

Definition at line 219 of file compobj.h.

References ener_euler.

## get_ff0()

const Scalar & Lorene::ScalarBH::get_ff0 | ( |  | ) | const

inline

Returns f0.

Definition at line 1078 of file compobj.h.

References ff0.

## get_ff1()

const Scalar & Lorene::ScalarBH::get_ff1 | ( |  | ) | const

inline

Definition at line 1079 of file compobj.h.

## get_ff2()

const Scalar & Lorene::ScalarBH::get_ff2 | ( |  | ) | const

inline

Definition at line 1080 of file compobj.h.

## get_gamma()

const Metric & Lorene::Compobj::get_gamma | ( |  | ) | const

inline inherited

Returns the 3-metric .

Definition at line 216 of file compobj.h.

References gamma.

## get_kk()

const Sym_tensor & Lorene::Compobj::get_kk | ( |  | ) | const

inline inherited

Returns the extrinsic curvature tensor .

Definition at line 228 of file compobj.h.

References kk.

## get_mom_euler()

const Vector & Lorene::Compobj::get_mom_euler | ( |  | ) | const

inline inherited

Returns the total 3-momentum density in the Eulerian frame.

Definition at line 222 of file compobj.h.

References mom_euler.

## get_mp()

const Map & Lorene::Compobj::get_mp | ( |  | ) | const

inline inherited

Returns the mapping.

Definition at line 207 of file compobj.h.

References Lorene::Map(), and mp.

## get_nn()

const Scalar & Lorene::Compobj::get_nn | ( |  | ) | const

inline inherited

Returns the lapse function N .

Definition at line 210 of file compobj.h.

References nn.

## get_rHor()

const double Lorene::ScalarBH::get_rHor | ( |  | ) | const

inline

Definition at line 1083 of file compobj.h.

## get_sfield()

const Scalar & Lorene::ScalarBH::get_sfield | ( |  | ) | const

inline

Definition at line 1082 of file compobj.h.

## get_stress_euler()

const Sym_tensor & Lorene::Compobj::get_stress_euler | ( |  | ) | const

inline inherited

Returns the stress tensor with respect to the Eulerian observer.

Definition at line 225 of file compobj.h.

References stress_euler.

## get_ww()

const Scalar & Lorene::ScalarBH::get_ww | ( |  | ) | const

inline

Definition at line 1081 of file compobj.h.

## gyoto_data()

void Lorene::Compobj::gyoto_data | ( | const char * | file_name | ) | const

inherited

Save in a file for GYOTO.

Definition at line 210 of file compobj.C.

References beta, Lorene::fwrite_be(), gamma, kk, mp, and nn.

## operator=()

void Lorene::ScalarBH::operator= | ( | const ScalarBH & | other | ) |

Assignment to another `ScalarBH`.

Definition at line 419 of file scalarBH.C.

References del_deriv(), Lorene::Compobj::operator=(), and ScalarBH().

## operator>>()

ostream & Lorene::ScalarBH::operator>> | ( | ostream & | ost | ) | const

protected virtual

Operator >> (virtual function called by the operator <<).

Reimplemented from Lorene::Compobj.

Definition at line 441 of file scalarBH.C.

References Lorene::Compobj::operator>>().

## sauve()

void Lorene::ScalarBH::sauve | ( | FILE * |  | ) | const

virtual

Save in a file.

Reimplemented from Lorene::Compobj.

Definition at line 433 of file scalarBH.C.

## set_der_0x0()

void Lorene::ScalarBH::set_der_0x0 | ( |  | ) | const

protected virtual

Sets to `0x0` all the pointers on derived quantities.

Definition at line 409 of file scalarBH.C.

## set_mp()

Map & Lorene::Compobj::set_mp | ( |  | ) |

inline inherited

Read/write of the mapping.

Definition at line 200 of file compobj.h.

References Lorene::Map(), and mp.

## update_metric()

void Lorene::ScalarBH::update_metric | ( |  | ) |

virtual

Definition at line 501 of file scalarBH.C.

## Member Data Documentation

## beta

Vector Lorene::Compobj::beta

protected inherited

Shift vector .

Definition at line 138 of file compobj.h.

## ener_euler

Scalar Lorene::Compobj::ener_euler

protected inherited

Total energy density E in the Eulerian frame.

Definition at line 144 of file compobj.h.

## ff0

Scalar Lorene::ScalarBH::ff0

protected

Metric field F_0 of Herdeiro & Radu (2015).

Definition at line 1028 of file compobj.h.

## ff1

Scalar Lorene::ScalarBH::ff1

protected

Metric field F_1 of Herdeiro & Radu (2015).

Definition at line 1029 of file compobj.h.

## ff2

Scalar Lorene::ScalarBH::ff2

protected

Metric field F_2 of Herdeiro & Radu (2015).

Definition at line 1030 of file compobj.h.

## gamma

Metric Lorene::Compobj::gamma

protected inherited

3-metric

Definition at line 141 of file compobj.h.

## kk

Sym_tensor Lorene::Compobj::kk

protected inherited

Extrinsic curvature tensor .

Definition at line 153 of file compobj.h.

## mom_euler

Vector Lorene::Compobj::mom_euler

protected inherited

Total 3-momentum density in the Eulerian frame.

Definition at line 147 of file compobj.h.

## mp

Map& Lorene::Compobj::mp

protected inherited

Mapping describing the coordinate system (r,theta,phi).

Definition at line 132 of file compobj.h.

## nn

Scalar Lorene::Compobj::nn

protected inherited

Lapse function N .

Definition at line 135 of file compobj.h.

## p_adm_mass

double* Lorene::Compobj::p_adm_mass

mutable protected inherited

ADM mass.

Definition at line 158 of file compobj.h.

## rHor

double Lorene::ScalarBH::rHor

protected

Event horizon coordinate radius.

Definition at line 1033 of file compobj.h.

## sfield

Scalar Lorene::ScalarBH::sfield

protected

Scalar field (modulus of Phi).

Definition at line 1032 of file compobj.h.

## stress_euler

Sym_tensor Lorene::Compobj::stress_euler

protected inherited

Stress tensor with respect to the Eulerian observer.

Definition at line 150 of file compobj.h.

## ww

Scalar Lorene::ScalarBH::ww

protected

Metric field W of Herdeiro & Radu (2015).

Definition at line 1031 of file compobj.h.

The documentation for this class was generated from the following files:

- compobj.h
- scalarBH.C